unit UDatStr;

interface

uses UDefinice;

type

//--------------PRVEK SEZNAMU POZIC-----------

// objekt pro uchovavani pozic, napr. seznam kamenu co beru pri 1 tahu

// vytvor - vytvori prvek s danymy PARAMS
// setPozice
// getPozice


  PPrvekSeznamuPozic = ^TPrvekSeznamuPozic;
  TPrvekSeznamuPozic = object
    public
      constructor vytvor( i,j: souradnice; next: PPrvekSeznamuPozic );
      procedure setPozice( i, j: souradnice );
      procedure getPozice( var i, j: souradnice );
      function getDalsi: PPrvekSeznamuPozic;
    private
      x, y: souradnice;
      dalsi: PPrvekSeznamuPozic;
  end;

//-------------SEZNAM POZIC------------------

// ZASOBNIK pozic

type
  PSeznamPozic = ^TSeznamPozic;
  TSeznamPozic = object
    public
      constructor vytvor;
      procedure init;
      procedure pridej( x, y : souradnice );
      function zkopiruj: PPrvekSeznamuPozic;
      function vyber( var x, y: souradnice ): boolean;   // vybere pozici zvrchu zasobniku
      procedure odeber;                                  // odebere --------II------------
      procedure vymazVse;
      destructor zrus;
    private
      zacatek: PPrvekSeznamuPozic;
  end;

//--------------PRVEK SEZNAMU TAHU------------

// objekt pro uchovavani tahu tzn. mista odkud kam tahnu a co pri tom beru

// 2 constructory - prvni vytvori tah dle danych PARAMS
//                - druhy             dle predlohy (totozny tah, okopiruje ho)
// porovnejTah - vraci TRUE pokud ma tah stejnou start. a cil. pozici jako PARAMS
// getDalsi
// destructor - vymaze (a dealokuje) seznam pozic

// startx, starty, cilx, cily - start. a cil. pozice
// seznamBrani - seznamPozic co vyhazuju

type
  PPrvekSeznamuTahu = ^TPrvekSeznamuTahu;
  TPrvekSeznamuTahu = object
    public
      constructor vytvor( sx, sy, cx, cy: souradnice; seznamBr: TSeznamPozic; next: PPrvekSeznamuTahu );
      constructor copy( vzor: PPrvekSeznamuTahu );
      procedure getSouradnice( var sx, sy, cx, cy: souradnice );
      function porovnejTah( sx, sy, cx, cy: souradnice): boolean;
      function vyberBrani( var bx, by: souradnice ): boolean;
      function getDalsi: PPrvekSeznamuTahu;
      destructor zrus;
    private
      startx, starty, cilx, cily: souradnice;
      seznamBrani: TSeznamPozic;
      dalsi: PPrvekSeznamuTahu;
  end;

//-------------SEZNAM TAHU---------------------


// ZASOBNIK tahu

// constructor vytvor - inicializuje zacatek
// pridej - vytvori a prida do seznamu tah se zadanymi PARAMS (seznamBrani kopiruje!!! (potreba dealokace) )
// prazdny - TRUE pokud seznam neobsahuje tah
// vyber - odebere tah z vrcholu zasobniku, vraci ukazatel na tento prvek
// vymazVse - vymazeVsecny tahy v seznamu
// najdiTah - vraci ukazatel na prvek s tahem odpovidajicim danym PARAMS
//            je to kopie prvku v seznamu, seznam to nemeni, zustava v puvodnim stavu
// destructor - vymaze (dealokuje) vse v seznamu

type
  PSeznamTahu = ^TSeznamTahu;
  TSeznamTahu = object
    public
      constructor vytvor;
      procedure pridej( sx, sy, cx, cy: souradnice; seznamBr: TSeznamPozic );
      function prazdny: boolean;
      function vyber: PPrvekSeznamuTahu;
      procedure vymazVse;
      function najdiTah( sx, sy, cx, cy: souradnice ): PPrvekSeznamuTahu;
      destructor zrus;
    private
      zacatek: PPrvekSeznamuTahu;
  end;


(******************************************************************************)
(******************************************************************************)

implementation


(******************************************************************************)
                   (*****   Objekt PrvekSeznamuPozic   *****)

constructor TPrvekSeznamuPozic.vytvor( i,j: souradnice; next: PPrvekSeznamuPozic );
begin
  x:= i;
  y:= j;
  dalsi:= next;
end;

procedure TPrvekSeznamuPozic.setPozice( i, j: souradnice );
begin
  x:= i;
  y:= j;
end;

procedure TPrvekSeznamuPozic.getPozice( var i, j: souradnice );
begin
  i:= x;
  j:= y;
end;

function TPrvekSeznamuPozic.getDalsi: PPrvekSeznamuPozic;
begin
  getDalsi:= dalsi;
end;
                   (*****   konec Objekt PrvekSeznamuPozic   *****)
(******************************************************************************)

(******************************************************************************)
                   (*****   Objekt SeznamPozic   *****)

constructor TSeznamPozic.vytvor;
begin
  zacatek:= NIL;
end;

procedure TSeznamPozic.init;
begin
  zacatek:= NIL;
end;

procedure TSeznamPozic.pridej( x, y : souradnice );
begin
  zacatek:= new( PPrvekSeznamuPozic, vytvor( x, y, zacatek ) );
end;

function TSeznamPozic.zkopiruj: PPrvekSeznamuPozic;
var
  p, zac, q: PPrvekSeznamuPozic;
  x, y: souradnice;
begin
  p:= zacatek;
  zac:= NIL;
  if ( p <> NIL ) then
  begin
    p^.getPozice( x, y );
    zac:= new( PPrvekSeznamuPozic, vytvor( x, y, NIL ) );
    q:= zac;
    p:= p^.getDalsi;
  end;

  while ( p <> NIL ) do
  begin
    p^.getPozice( x, y );
    q^.dalsi:= new( PPrvekSeznamuPozic, vytvor( x, y, NIL ) );
    p:= p^.getDalsi;
    q:= q^.getDalsi;
  end;

  zkopiruj:= zac;
end;

function TSeznamPozic.vyber( var x, y: souradnice ): boolean;
var
  p: PPrvekSeznamuPozic;
begin
  if (zacatek <> NIL ) then
  begin
    p:= zacatek;
    zacatek:= zacatek^.getDalsi;
    p^.getPozice( x, y );
    dispose( p );
    vyber:= TRUE;
  end
  else
    vyber:= FALSE;
end;

procedure TSeznamPozic.odeber;
var
  p: PPrvekSeznamuPozic;
begin
  p:= zacatek;
  zacatek:= zacatek^.getDalsi;
  dispose( p );
end;

procedure TSeznamPozic.vymazVse;
begin
  while ( zacatek <> NIL) do
    odeber;
end;

destructor TSeznamPozic.zrus;
begin
  vymazVse;
end;

                   (*****   konec Objekt SeznamPozic   *****)
(******************************************************************************)

(******************************************************************************)
                   (*****   Objekt prvek seznamu tahu   *****)

constructor TPrvekSeznamuTahu.vytvor( sx, sy, cx, cy: souradnice; seznamBr: TSeznamPozic; next: PPrvekSeznamuTahu );
begin
  startx:= sx;
  starty:= sy;
  cilx:= cx;
  cily:= cy;
  seznamBrani.zacatek:= seznamBr.zkopiruj;
  dalsi:= next;
end;

constructor TPrvekSeznamuTahu.copy( vzor: PPrvekSeznamuTahu );
begin
  startx:= vzor^.startx;
  starty:= vzor^.starty;
  cilx:=   vzor^.cilx;
  cily:=   vzor^.cily;
  seznamBrani.zacatek:= vzor^.seznamBrani.zkopiruj;
end;

procedure TPrvekSeznamuTahu.getSouradnice( var sx, sy, cx, cy: souradnice );
begin
  sx:= startX;
  sy:= startY;
  cx:= cilX;
  cy:= cilY;
end;

function TPrvekSeznamuTahu.porovnejTah( sx, sy, cx, cy: souradnice): boolean;
begin
  if (sx = startx) and (sy = starty) and (cx = cilx) and (cy = cily) then
    porovnejTah:= TRUE
  else
    porovnejTah:= FAlSE;
end;

function TPrvekSeznamuTahu.vyberBrani( var bx, by: souradnice ): boolean;
begin
  vyberBrani:= seznamBrani.vyber( bx, by );
end;

function TPrvekSeznamuTahu.getDalsi: PPrvekSeznamuTahu;
begin
  getDalsi:= dalsi;
end;

destructor TPrvekSeznamuTahu.zrus;
begin
  if (@self <> NIL) then
    seznamBrani.vymazVse;
end;

                   (*****   konec Objekt prvek seznamu tahu   *****)
(******************************************************************************)

(******************************************************************************)
                   (*****    objekt seznamu tahu   *****)

constructor TSeznamTahu.vytvor;
begin
  zacatek:= NIL;
end;

procedure TSeznamTahu.pridej( sx, sy, cx, cy: souradnice; seznamBr: TSeznamPozic );
var
  p: PPrvekSeznamuTahu;
begin
  p:= new( PPrvekSeznamuTahu, vytvor( sx, sy, cx, cy, seznamBr, zacatek ) );
  zacatek:= p;
end;

function TSeznamTahu.prazdny: boolean;
begin
  if (zacatek = NIL) then
    prazdny:= TRUE
  else
    prazdny:= FALSE;
end;

function TSeznamTahu.vyber: PPrvekSeznamUTahu;
begin
  if (zacatek <> NIL) then
  begin
    vyber:= zacatek;
    zacatek:= zacatek^.getDalsi;
  end
  else
    vyber:= NIL;
end;

procedure TSeznamTahu.vymazVse;
var
  p: PPrvekSeznamuTahu;
begin
  while (zacatek <> NIL) do
  begin
    p:= zacatek;
    zacatek:= zacatek^.getDalsi;
    dispose( p, zrus );
  end;
end;

function TSeznamTahu.najdiTah( sx, sy, cx, cy: souradnice ): PPrvekSeznamuTahu;
var
  p: PPrvekSeznamuTahu;
begin
  p:= zacatek;

  while (p <> NIL) do
  begin
    if p^.porovnejTah( sx, sy, cx, cy ) then
    begin
      najdiTah:= new( PPrvekSeznamuTahu, copy( p ) );
      exit;
    end;
    p:= p^.getDalsi;
  end;

  najdiTah:= NIL;
end;

destructor TSeznamTahu.zrus;
begin
  vymazVse;
end;

                  (*****    konec objekt seznamu tahu   *****)
(******************************************************************************)

end.