unit UGenerator;

interface

uses UDefinice, UDatStr;

// Generator - vygeneruje vsechny mozne tahy z dane situace herni desky
//             a ulozi je do spojoveho seznamu ( objekt seznam tahu )

// generuj - generuje ty tahy. PARAMS- kdo je na tahu, herni situace, kam ma ulozit tahy
// normal -
// dama -
// brani - max.pocet brani ktere mohou nastat v nejakem z dosud nalezenych tahu
//         ty s mensim poctem nema smysl prochazet diky pravidlu muzes brat = musis brat
// sx, sy - startovni pozice z kterych figura tahne, pouziva se v rekurzi
//           -> nebudu muset predavat jako parametry do vsech volani

type
  TGenerator = object
    public
      procedure generuj( natahu: TypBarvy; hraciPole: THraciPole; var kam: TSeznamTahu );
    private
      brani: integer;
      sx, sy: souradnice;
      procedure normalCerveny( x, y : souradnice; hraciPole: THraciPole;
                               var kam: TSeznamTahu;
                               pocetBrani: integer; seznamBrani: TSeznamPozic );
      procedure normalModry  ( x, y : souradnice; hraciPole: THraciPole;
                               var kam: TSeznamTahu;
                               pocetBrani: integer; seznamBrani: TSeznamPozic );
      procedure damaCerveny( x, y: souradnice; var hraciPole: THraciPole;
                             var kam: TSeznamTahu;
                             pocetBrani: integer; seznamBrani: TSeznamPozic;
                             smer: TSmer );
      procedure damaCervenyJZ( x, y: souradnice; var hraciPole: THraciPole;
                               var kam: TSeznamTahu;
                               pocetBrani: integer; seznamBrani: TSeznamPozic );
      procedure damaCervenyJV( x, y: souradnice; var hraciPole: THraciPole;
                               var kam: TSeznamTahu;
                               pocetBrani: integer; seznamBrani: TSeznamPozic );
      procedure damaCervenySV( x, y: souradnice; var hraciPole: THraciPole;
                               var kam: TSeznamTahu;
                               pocetBrani: integer; seznamBrani: TSeznamPozic );
      procedure damaCervenySZ( x, y: souradnice; var hraciPole: THraciPole;
                               var kam: TSeznamTahu;
                               pocetBrani: integer; seznamBrani: TSeznamPozic );
      procedure damaModry( x, y: souradnice; var hraciPole: THraciPole;
                           var kam: TSeznamTahu;
                           pocetBrani: integer; seznamBrani: TSeznamPozic;
                           smer: TSmer );
      procedure damaModryJZ( x, y: souradnice; var hraciPole: THraciPole;
                             var kam: TSeznamTahu;
                             pocetBrani: integer; seznamBrani: TSeznamPozic );
      procedure damaModryJV( x, y: souradnice; var hraciPole: THraciPole;
                             var kam: TSeznamTahu;
                             pocetBrani: integer; seznamBrani: TSeznamPozic );
      procedure damaModrySV( x, y: souradnice; var hraciPole: THraciPole;
                             var kam: TSeznamTahu;
                             pocetBrani: integer; seznamBrani: TSeznamPozic );
      procedure damaModrySZ( x, y: souradnice; var hraciPole: THraciPole;
                             var kam: TSeznamTahu;
                             pocetBrani: integer; seznamBrani: TSeznamPozic );
  end; 

var
  Generator: TGenerator;


implementation



(******************************************************************************)
                  (*****    objekt generator tahu   *****)



procedure TGenerator.generuj( natahu: TypBarvy; hraciPole: THraciPole; var kam: TSeznamTahu );
var
  seznamBrani: TSeznamPozic;
  i, j: souradnice;
begin
  brani:= 0;                  // inicializuju kolikrat je mozno z dane pozice brat
  seznamBrani.init;

  case naTahu of              // podle toho kdo je na tahu
    Cerveny:
      begin
        for i:= 1 to 8 do    // projdu cele hraci pole (hledam kameny cerveneho)
        for j:= 1 to 8 do
        begin
          sx:= i;
          sy:= j;
          if hraciPole[ sx, sy] = 1 then              // normalni kamen cerveneho
            normalCerveny( sx, sy, hraciPole, kam, 0, seznamBrani );
          if hraciPole[ sx, sy] = 2 then              // dama cerveneho
            damaCerveny( sx, sy, hraciPole, kam, 0, seznamBrani, O );
        end;
      end;
    Modry:
      begin
        for i:= 1 to 8 do    // projdu cele hraci pole (hledam kameny modreho)
        for j:= 1 to 8 do
        begin
          sx:= i;
          sy:= j;
          if hraciPole[ sx, sy] = -1 then             // normalni kamen modreho
            normalModry( sx, sy, hraciPole, kam, 0, seznamBrani );
          if hraciPole[ sx, sy] = -2 then             // dama modreho
            damaModry( sx, sy, hraciPole, kam, 0, seznamBrani, O );
        end;
      end;
  end;
end;


procedure TGenerator.normalCerveny( x, y : souradnice; hraciPole: THraciPole;
                                    var kam: TSeznamTahu;
                                    pocetBrani: integer; seznamBrani: TSeznamPozic );
var
  coBeru: TypKamenu;
begin
// proberu moznosti kde se nebere
  if (pocetBrani = 0) and (brani = 0) then    // nemusim skakat a neskakal jsem
  begin
    if (x > 1) and (y > 1) then               // figurka neni u praveho ani horniho okraje
      if (hraciPole[ x-1, y-1] = 0) then      // pozice je prazdna
        kam.pridej( sx, sy, x-1, y-1, seznamBrani );
    if (x < 8) and (y > 1) then               // figurka neni u leveho ani horniho okraje
      if (hraciPole[ x+1, y-1] = 0) then      // pozice je prazdna
        kam.pridej( sx, sy, x+1, y-1, seznamBrani );
  end;

// ted moznosti s branim
  if (x > 2) and (y > 2) then
    if (hraciPole[ x-1, y-1] < 0) and (hraciPole[ x-2, y-2] = 0) then   // mam co skocit AND kam skocit
    begin
      coBeru:=  hraciPole[ x-1, y-1];    // ulozim co bych pri tomto tahu bral
      hraciPole[   x,   y]:= 0;          // skacu odsud
      hraciPole[ x-1, y-1]:= 0;          // beru kamen
      hraciPole[ x-2, y-2]:= 1;          // skacu sem
      seznamBrani.pridej( x-1, y-1 );    // pridam, kterou pozici bych sebral
      normalCerveny( x-2, y-2, hraciPole, kam, pocetBrani + 1, seznamBrani);    //

      hraciPole[   x,   y]:= 1;          // vracim se odkud jsem skakal
      hraciPole[ x-1, y-1]:= coBeru;     // vracim co jsem bral
      hraciPole[ x-2, y-2]:= 0;          // vracim kam jsem skakal
      seznamBrani.odeber;
    end;

  if (x < 7) and (y > 2) then
    if (hraciPole[ x+1, y-1] < 0) and (hraciPole[ x+2, y-2] = 0) then
    begin
      coBeru:=  hraciPole[ x+1, y-1];
      hraciPole[   x,   y]:= 0;
      hraciPole[ x+1, y-1]:= 0;
      hraciPole[ x+2, y-2]:= 1;
      seznamBrani.pridej( x+1, y-1 );
      normalCerveny( x+2, y-2, hraciPole, kam, pocetBrani + 1, seznamBrani);

      hraciPole[   x,   y]:= 1;
      hraciPole[ x+1, y-1]:= coBeru;
      hraciPole[ x+2, y-2]:= 0;
      seznamBrani.odeber;
    end;

// moznosti probrany zkusit jestli je to platny tah (mam ho ulozit)
  if (pocetBrani > 0) then          // uz jsem skakal
  begin
    if (pocetBrani = brani) then    // skocil jsem tolikrat jako nekdy predtim
      kam.pridej(sx, sy, x, y, seznamBrani );   // pridat akt. tah

    if (pocetBrani > brani) then    // skocil jsem vicekrat jako nekdy predtim
    begin
      kam.vymazVse;                 // tahy z predtim skacou malokrat = nesmi se tak skakat
      brani:= pocetBrani;           // muzu skocit alespon tolikrat
      kam.pridej( sx, sy, x, y, SeznamBrani );  // pridat akt. tah
    end;
  end;
end;


procedure TGenerator.normalModry( x, y : souradnice; hraciPole: THraciPole;
                                  var kam: TSeznamTahu;
                                  pocetBrani: integer; seznamBrani: TSeznamPozic );
var
  coBeru: TypKamenu;
begin
// proberu moznosti kde se nebere
  if (pocetBrani = 0) and (brani = 0) then    // nemusim skakat a neskakal jsem
  begin
    if (x > 1) and (y < 8) then               // figurka neni u praveho ani dolniho okraje
      if (hraciPole[ x-1, y+1] = 0) then      // pozice je prazdna
        kam.pridej( sx, sy, x-1, y+1, seznamBrani );
    if (x < 8) and (y < 8) then               // figurka neni u leveho ani dolniho okraje
      if (hraciPole[ x+1, y+1] = 0) then      // pozice je prazdna
        kam.pridej( sx, sy, x+1, y+1, seznamBrani );
  end;

// ted moznosti s branim
  if (x > 2) and (y < 7) then
    if (hraciPole[ x-1, y+1] > 0) and (hraciPole[ x-2, y+2] = 0) then   // mam co skocit AND kam skocit
    begin
      coBeru:=  hraciPole[ x-1, y+1];    // ulozim co bych pri tomto tahu bral
      hraciPole[   x,   y]:= 0;          // skacu odsud
      hraciPole[ x-1, y+1]:= 0;          // beru kamen
      hraciPole[ x-2, y+2]:= 1;          // skacu sem
      seznamBrani.pridej( x-1, y+1 );    // pridam, kterou pozici bych sebral
      normalModry( x-2, y+2, hraciPole, kam, pocetBrani + 1, seznamBrani);    //

      hraciPole[   x,   y]:= 1;          // vracim se odkud jsem skakal
      hraciPole[ x-1, y+1]:= coBeru;     // vracim co jsem bral
      hraciPole[ x-2, y+2]:= 0;          // vracim kam jsem skakal
      seznamBrani.odeber;
    end;

  if (x < 7) and (y < 7) then
    if (hraciPole[ x+1, y+1] > 0) and (hraciPole[ x+2, y+2] = 0) then
    begin
      coBeru:=  hraciPole[ x+1, y+1];
      hraciPole[   x,   y]:= 0;
      hraciPole[ x+1, y+1]:= 0;
      hraciPole[ x+2, y+2]:= 1;
      seznamBrani.pridej( x+1, y+1 );
      normalModry( x+2, y+2, hraciPole, kam, pocetBrani + 1, seznamBrani);

      hraciPole[   x,   y]:= 1;
      hraciPole[ x+1, y+1]:= coBeru;
      hraciPole[ x+2, y+2]:= 0;
      seznamBrani.odeber;
    end;

// moznosti probrany zkusit jestli je to platny tah (mam ho ulozit)
  if (pocetBrani > 0) then          // uz jsem skakal
  begin
    if (pocetBrani = brani) then    // skocil jsem tolikrat jako nekdy predtim
      kam.pridej(sx, sy, x, y, seznamBrani );   // pridat akt. tah

    if (pocetBrani > brani) then    // skocil jsem vicekrat jako nekdy predtim
    begin
      kam.vymazVse;                 // tahy z predtim skacou malokrat = nesmi se tak skakat
      brani:= pocetBrani;           // muzu skocit alespon tolikrat
      kam.pridej( sx, sy, x, y, SeznamBrani );  // pridat akt. tah
    end;
  end;
end;

procedure TGenerator.damaCerveny( x, y: souradnice; var hraciPole: THraciPole;
                                  var kam: TSeznamTahu;
                                  pocetBrani: integer; seznamBrani: TSeznamPozic;
                                  smer: TSmer );
begin
  if (smer <> JZ) then
    damaCervenySV( x, y, hraciPole, kam, pocetBrani, seznamBrani );
  if (smer <> JV) then
    damaCervenySZ( x, y, hraciPole, kam, pocetBrani, seznamBrani );
  if (smer <> SV) then
    damaCervenyJZ( x, y, hraciPole, kam, pocetBrani, seznamBrani );
  if (smer <> SZ) then
    damaCervenyJV( x, y, hraciPole, kam, pocetBrani, seznamBrani );
end;

procedure TGenerator.damaCervenyJZ( x, y: souradnice; var hraciPole: THraciPole;
                                    var kam: TSeznamTahu;
                                    pocetBrani: integer; seznamBrani: TSeznamPozic );
var
  i, j, bx, by: souradnice;
  kamen: TypKamenu;
begin
  i:= x-1;
  j:= y+1;

  while ( (i >= 1) and (j <= 8) and (hraciPole[ i, j] = 0) ) do   // posunuju damou smerem na JZ
  begin
    if ( (pocetBrani = 0) and (brani = 0) ) then
      kam.pridej( sx, sy, i, j, seznamBrani );   // pridani tohoto tahu, zde se take nebere
    i:= i-1;
    j:= j+1;
  end;

  if ( (i > 1) and (j < 8) and (hraciPole[ i, j] < 0) ) then   // je tam figura co mohu sebrat (nesmi byt u okraje a musi byt modra)
  begin
    bx:= i;                          // zapamatovat pozici co bych bral
    by:= j;
    kamen:= hraciPole[ bx, by ];     // zapamatovat kamen
    hraciPole[ bx, by ]:= 0;         // vzit ho
    seznamBrani.pridej( bx, by );    
    pocetBrani:= pocetBrani +1;
    i:= i-1;                         // posun na dalsi pole
    j:= j+1;
    while ( (i >= 1) and (j <= 8) and (hraciPole[ i, j] = 0) ) do
    begin    // neni pres levy AND dolni okraj AND prazdne policko
      hraciPole[ x, y ]:= 0;
      hraciPole[ i, j ]:= 2;
      damaCerveny( i, j, hraciPole, kam, pocetBrani, seznamBrani, JZ );
      if ( pocetBrani = brani ) then
        kam.pridej( sx, sy, i, j, seznamBrani );
      if ( pocetBrani > brani ) then
      begin
        kam.vymazVse;
        brani:= pocetBrani;
        kam.pridej( sx, sy, i, j, seznamBrani );
      end;
      hraciPole[ i, j ]:= 0;
      hraciPole[ x, y ]:= 2;
      i:= i-1;                         // posun na dalsi pole
      j:= j+1;
    end;
    seznamBrani.odeber;              // vratit kamen
    pocetBrani:= pocetBrani -1;
    hraciPole[ bx, by ]:= kamen;
  end;
end;

procedure TGenerator.damaCervenyJV( x, y: souradnice; var hraciPole: THraciPole;
                                    var kam: TSeznamTahu;
                                    pocetBrani: integer; seznamBrani: TSeznamPozic );
var
  i, j, bx, by: souradnice;
  kamen: TypKamenu;
begin
  i:= x+1;
  j:= y+1;

  while ( (i <= 8) and (j <= 8) and (hraciPole[ i, j] = 0) ) do   // posunuju damou smerem na JV
  begin
    if ( (pocetBrani = 0) and (brani = 0) ) then
      kam.pridej( sx, sy, i, j, seznamBrani );   // pridani tohoto tahu, zde se take nebere
    i:= i+1;
    j:= j+1;
  end;

  if ( (i < 8) and (j < 8) and (hraciPole[ i, j] < 0) ) then   // je tam figura co mohu sebrat (nesmi byt u okraje a musi byt modra)
  begin
    bx:= i;                          // zapamatovat pozici co bych bral
    by:= j;
    kamen:= hraciPole[ bx, by ];     // zapamatovat kamen
    hraciPole[ bx, by ]:= 0;         // vzit ho
    seznamBrani.pridej( bx, by );    
    pocetBrani:= pocetBrani +1;
    i:= i+1;                         // posun na dalsi pole
    j:= j+1;
    while ( (i <= 8) and (j <= 8) and (hraciPole[ i, j] = 0) ) do
    begin    // neni pres pravy AND dolni okraj AND prazdne policko
      hraciPole[ x, y ]:= 0;
      hraciPole[ i, j ]:= 2;
      damaCerveny( i, j, hraciPole, kam, pocetBrani, seznamBrani, JV );
      if ( pocetBrani = brani ) then
        kam.pridej( sx, sy, i, j, seznamBrani );
      if ( pocetBrani > brani ) then
      begin
        kam.vymazVse;
        brani:= pocetBrani;
        kam.pridej( sx, sy, i, j, seznamBrani );
      end;
      hraciPole[ i, j ]:= 0;
      hraciPole[ x, y ]:= 2;
      i:= i+1;                         // posun na dalsi pole
      j:= j+1;
    end;
    seznamBrani.odeber;              // vratit kamen
    pocetBrani:= pocetBrani -1;
    hraciPole[ bx, by ]:= kamen;
  end;
end;

procedure TGenerator.damaCervenySV( x, y: souradnice; var hraciPole: THraciPole;
                                    var kam: TSeznamTahu;
                                    pocetBrani: integer; seznamBrani: TSeznamPozic );
var
  i, j, bx, by: souradnice;
  kamen: TypKamenu;
begin
  i:= x+1;
  j:= y-1;

  while ( (i <= 8) and (j >= 1) and (hraciPole[ i, j] = 0) ) do   // posunuju damou smerem na SV
  begin
    if ( (pocetBrani = 0) and (brani = 0) ) then
      kam.pridej( sx, sy, i, j, seznamBrani );   // pridani tohoto tahu, zde se take nebere
    i:= i+1;
    j:= j-1;
  end;

  if ( (i < 8) and (j > 1) and (hraciPole[ i, j] < 0) ) then   // je tam figura co mohu sebrat (nesmi byt u okraje a musi byt modra)
  begin
    bx:= i;                          // zapamatovat pozici co bych bral
    by:= j;
    kamen:= hraciPole[ bx, by ];     // zapamatovat kamen
    hraciPole[ bx, by ]:= 0;         // vzit ho
    seznamBrani.pridej( bx, by );    
    pocetBrani:= pocetBrani +1;
    i:= i+1;                         // posun na dalsi pole
    j:= j-1;
    while ( (i <= 8) and (j >= 1) and (hraciPole[ i, j] = 0) ) do
    begin    // neni pres pravy AND horni okraj AND prazdne policko
      hraciPole[ x, y ]:= 0;
      hraciPole[ i, j ]:= 2;
      damaCerveny( i, j, hraciPole, kam, pocetBrani, seznamBrani, SV );
      if ( pocetBrani = brani ) then
        kam.pridej( sx, sy, i, j, seznamBrani );
      if ( pocetBrani > brani ) then
      begin
        kam.vymazVse;
        brani:= pocetBrani;
        kam.pridej( sx, sy, i, j, seznamBrani );
      end;
      hraciPole[ i, j ]:= 0;
      hraciPole[ x, y ]:= 2;
      i:= i+1;                         // posun na dalsi pole
      j:= j-1;
    end;
    seznamBrani.odeber;              // vratit kamen
    pocetBrani:= pocetBrani -1;
    hraciPole[ bx, by ]:= kamen;
  end;
end;

procedure TGenerator.damaCervenySZ( x, y: souradnice; var hraciPole: THraciPole;
                                    var kam: TSeznamTahu;
                                    pocetBrani: integer; seznamBrani: TSeznamPozic );
var
  i, j, bx, by: souradnice;
  kamen: TypKamenu;
begin
  i:= x-1;
  j:= y-1;

  while ( (i >= 1) and (j >= 1) and (hraciPole[ i, j] = 0) ) do   // posunuju damou smerem na JV
  begin
    if ( (pocetBrani = 0) and (brani = 0) ) then
      kam.pridej( sx, sy, i, j, seznamBrani );   // pridani tohoto tahu, zde se take nebere
    i:= i-1;
    j:= j-1;
  end;

  if ( (i > 1) and (j > 1) and (hraciPole[ i, j] < 0) ) then   // je tam figura co mohu sebrat (nesmi byt u okraje a musi byt modra)
  begin
    bx:= i;                          // zapamatovat pozici co bych bral
    by:= j;
    kamen:= hraciPole[ bx, by ];     // zapamatovat kamen
    hraciPole[ bx, by ]:= 0;         // vzit ho
    seznamBrani.pridej( bx, by );   
    pocetBrani:= pocetBrani +1;
    i:= i-1;                         // posun na dalsi pole
    j:= j-1;
    while ( (i >= 1) and (j >= 1) and (hraciPole[ i, j] = 0) ) do
    begin    // neni pres pravy AND dolni okraj AND prazdne policko
      hraciPole[ x, y ]:= 0;
      hraciPole[ i, j ]:= 2;
      damaCerveny( i, j, hraciPole, kam, pocetBrani, seznamBrani, SZ );
      if ( pocetBrani = brani ) then
        kam.pridej( sx, sy, i, j, seznamBrani );
      if ( pocetBrani > brani ) then
      begin
        kam.vymazVse;
        brani:= pocetBrani;
        kam.pridej( sx, sy, i, j, seznamBrani );
      end;
      hraciPole[ i, j ]:= 0;
      hraciPole[ x, y ]:= 2;
      i:= i-1;                         // posun na dalsi pole
      j:= j-1;
    end;
    seznamBrani.odeber;              // vratit kamen
    pocetBrani:= pocetBrani -1;
    hraciPole[ bx, by ]:= kamen;
  end;
end;

procedure TGenerator.damaModry( x, y: souradnice; var hraciPole: THraciPole;
                                  var kam: TSeznamTahu;
                                  pocetBrani: integer; seznamBrani: TSeznamPozic;
                                  smer: TSmer );
begin
  if (smer <> JZ) then
    damaModrySV( x, y, hraciPole, kam, pocetBrani, seznamBrani );
  if (smer <> JV) then
    damaModrySZ( x, y, hraciPole, kam, pocetBrani, seznamBrani );
  if (smer <> SV) then
    damaModryJZ( x, y, hraciPole, kam, pocetBrani, seznamBrani );
  if (smer <> SZ) then
    damaModryJV( x, y, hraciPole, kam, pocetBrani, seznamBrani );
end;

procedure TGenerator.damaModryJZ( x, y: souradnice; var hraciPole: THraciPole;
                                    var kam: TSeznamTahu;
                                    pocetBrani: integer; seznamBrani: TSeznamPozic );
var
  i, j, bx, by: souradnice;
  kamen: TypKamenu;
begin
  i:= x-1;
  j:= y+1;

  while ( (i >= 1) and (j <= 8) and (hraciPole[ i, j] = 0) ) do   // posunuju damou smerem na JZ
  begin
    if ( (pocetBrani = 0) and (brani = 0) ) then
      kam.pridej( sx, sy, i, j, seznamBrani );   // pridani tohoto tahu, zde se take nebere
    i:= i-1;
    j:= j+1;
  end;

  if ( (i > 1) and (j < 8) and (hraciPole[ i, j] > 0) ) then   // je tam figura co mohu sebrat (nesmi byt u okraje a musi byt modra)
  begin
    bx:= i;                          // zapamatovat pozici co bych bral
    by:= j;
    kamen:= hraciPole[ bx, by ];     // zapamatovat kamen
    hraciPole[ bx, by ]:= 0;         // vzit ho
    seznamBrani.pridej( bx, by );    
    pocetBrani:= pocetBrani +1;
    i:= i-1;                         // posun na dalsi pole
    j:= j+1;
    while ( (i >= 1) and (j <= 8) and (hraciPole[ i, j] = 0) ) do
    begin    // neni pres levy AND dolni okraj AND prazdne policko
      hraciPole[ x, y ]:= 0;
      hraciPole[ i, j ]:= -2;
      damaModry( i, j, hraciPole, kam, pocetBrani, seznamBrani, JZ );
      if ( pocetBrani = brani ) then
        kam.pridej( sx, sy, i, j, seznamBrani );
      if ( pocetBrani > brani ) then
      begin
        kam.vymazVse;
        brani:= pocetBrani;
        kam.pridej( sx, sy, i, j, seznamBrani );
      end;
      hraciPole[ i, j ]:= 0;
      hraciPole[ x, y ]:= -2;
      i:= i-1;                         // posun na dalsi pole
      j:= j+1;
    end;
    seznamBrani.odeber;              // vratit kamen
    pocetBrani:= pocetBrani -1;
    hraciPole[ bx, by ]:= kamen;
  end;
end;

procedure TGenerator.damaModryJV( x, y: souradnice; var hraciPole: THraciPole;
                                    var kam: TSeznamTahu;
                                    pocetBrani: integer; seznamBrani: TSeznamPozic );
var
  i, j, bx, by: souradnice;
  kamen: TypKamenu;
begin
  i:= x+1;
  j:= y+1;

  while ( (i <= 8) and (j <= 8) and (hraciPole[ i, j] = 0) ) do   // posunuju damou smerem na JV
  begin
    if ( (pocetBrani = 0) and (brani = 0) ) then
      kam.pridej( sx, sy, i, j, seznamBrani );   // pridani tohoto tahu, zde se take nebere
    i:= i+1;
    j:= j+1;
  end;

  if ( (i < 8) and (j < 8) and (hraciPole[ i, j] > 0) ) then   // je tam figura co mohu sebrat (nesmi byt u okraje a musi byt modra)
  begin
    bx:= i;                          // zapamatovat pozici co bych bral
    by:= j;
    kamen:= hraciPole[ bx, by ];     // zapamatovat kamen
    hraciPole[ bx, by ]:= 0;         // vzit ho
    seznamBrani.pridej( bx, by );    
    pocetBrani:= pocetBrani +1;
    i:= i+1;                         // posun na dalsi pole
    j:= j+1;
    while ( (i <= 8) and (j <= 8) and (hraciPole[ i, j] = 0) ) do
    begin    // neni pres pravy AND dolni okraj AND prazdne policko
      hraciPole[ x, y ]:= 0;
      hraciPole[ i, j ]:= -2;
      damaModry( i, j, hraciPole, kam, pocetBrani, seznamBrani, JV );
      if ( pocetBrani = brani ) then
        kam.pridej( sx, sy, i, j, seznamBrani );
      if ( pocetBrani > brani ) then
      begin
        kam.vymazVse;
        brani:= pocetBrani;
        kam.pridej( sx, sy, i, j, seznamBrani );
      end;
      hraciPole[ i, j ]:= 0;
      hraciPole[ x, y ]:= -2;
      i:= i+1;                         // posun na dalsi pole
      j:= j+1;
    end;
    seznamBrani.odeber;              // vratit kamen
    pocetBrani:= pocetBrani -1;
    hraciPole[ bx, by ]:= kamen;
  end;
end;

procedure TGenerator.damaModrySV( x, y: souradnice; var hraciPole: THraciPole;
                                    var kam: TSeznamTahu;
                                    pocetBrani: integer; seznamBrani: TSeznamPozic );
var
  i, j, bx, by: souradnice;
  kamen: TypKamenu;
begin
  i:= x+1;
  j:= y-1;

  while ( (i <= 8) and (j >= 1) and (hraciPole[ i, j] = 0) ) do   // posunuju damou smerem na SV
  begin
    if ( (pocetBrani = 0) and (brani = 0) ) then
      kam.pridej( sx, sy, i, j, seznamBrani );   // pridani tohoto tahu, zde se take nebere
    i:= i+1;
    j:= j-1;
  end;

  if ( (i < 8) and (j > 1) and (hraciPole[ i, j] > 0) ) then   // je tam figura co mohu sebrat (nesmi byt u okraje a musi byt modra)
  begin
    bx:= i;                          // zapamatovat pozici co bych bral
    by:= j;
    kamen:= hraciPole[ bx, by ];     // zapamatovat kamen
    hraciPole[ bx, by ]:= 0;         // vzit ho
    seznamBrani.pridej( bx, by );    
    pocetBrani:= pocetBrani +1;
    i:= i+1;                         // posun na dalsi pole
    j:= j-1;
    while ( (i <= 8) and (j >= 1) and (hraciPole[ i, j] = 0) ) do
    begin    // neni pres pravy AND horni okraj AND prazdne policko
      hraciPole[ x, y ]:= 0;
      hraciPole[ i, j ]:= -2;
      damaModry( i, j, hraciPole, kam, pocetBrani, seznamBrani, SV );
      if ( pocetBrani = brani ) then
        kam.pridej( sx, sy, i, j, seznamBrani );
      if ( pocetBrani > brani ) then
      begin
        kam.vymazVse;
        brani:= pocetBrani;
        kam.pridej( sx, sy, i, j, seznamBrani );
      end;
      hraciPole[ i, j ]:= 0;
      hraciPole[ x, y ]:= -2;
      i:= i+1;                         // posun na dalsi pole
      j:= j-1;
    end;
    seznamBrani.odeber;              // vratit kamen
    pocetBrani:= pocetBrani -1;
    hraciPole[ bx, by ]:= kamen;
  end;
end;

procedure TGenerator.damaModrySZ( x, y: souradnice; var hraciPole: THraciPole;
                                    var kam: TSeznamTahu;
                                    pocetBrani: integer; seznamBrani: TSeznamPozic );
var
  i, j, bx, by: souradnice;
  kamen: TypKamenu;
begin
  i:= x-1;
  j:= y-1;

  while ( (i >= 1) and (j >= 1) and (hraciPole[ i, j] = 0) ) do   // posunuju damou smerem na JV
  begin
    if ( (pocetBrani = 0) and (brani = 0) ) then
      kam.pridej( sx, sy, i, j, seznamBrani );   // pridani tohoto tahu, zde se take nebere
    i:= i-1;
    j:= j-1;
  end;

  if ( (i > 1) and (j > 1) and (hraciPole[ i, j] > 0) ) then   // je tam figura co mohu sebrat (nesmi byt u okraje a musi byt modra)
  begin
    bx:= i;                          // zapamatovat pozici co bych bral
    by:= j;
    kamen:= hraciPole[ bx, by ];     // zapamatovat kamen
    hraciPole[ bx, by ]:= 0;         // vzit ho
    seznamBrani.pridej( bx, by );    
    pocetBrani:= pocetBrani +1;
    i:= i-1;                         // posun na dalsi pole
    j:= j-1;
    while ( (i >= 1) and (j >= 1) and (hraciPole[ i, j] = 0) ) do
    begin    // neni pres pravy AND dolni okraj AND prazdne policko
      hraciPole[ x, y ]:= 0;
      hraciPole[ i, j ]:= -2;
      damaModry( i, j, hraciPole, kam, pocetBrani, seznamBrani, SZ );
      if ( pocetBrani = brani ) then
        kam.pridej( sx, sy, i, j, seznamBrani );
      if ( pocetBrani > brani ) then
      begin
        kam.vymazVse;
        brani:= pocetBrani;
        kam.pridej( sx, sy, i, j, seznamBrani );
      end;
      hraciPole[ i, j ]:= 0;
      hraciPole[ x, y ]:= -2;
      i:= i-1;                         // posun na dalsi pole
      j:= j-1;
    end;
    seznamBrani.odeber;              // vratit kamen
    pocetBrani:= pocetBrani -1;
    hraciPole[ bx, by ]:= kamen;
  end;
end;


                  (*****    konec objekt generator tahu   *****)
(******************************************************************************)

end.