unit UHra;

interface

uses UDefinice, UGenerator, UKreslic, UPocitac, UDatStr;

type
  THra = object
    public
      procedure init( red, blue: TypHrace );
      procedure ovladani( x, y: souradnice );
      procedure hraj;
    private
      naTahu: TypBarvy;
      hraci: TPoleHraci;
      hraciPole: ThraciPole;
      reaguj: boolean;
      oznacenoX, oznacenoY: integer;
      procedure vykresliVse;
      procedure zmenaVDamy;
      function  konec: boolean;
      procedure tahni( pTah: PPrvekSeznamuTahu);
  end;
  

var
  Hra: THra;


implementation

uses Unit1, Unit3;

(******************************************************************************)
                  (*****    objekt hra   *****)


procedure THra.init( red, blue: TypHrace );
var
  i, j: souradnice;
begin
  naTahu:= Cerveny;

  hraci[ Cerveny]:= red;
  hraci[ Modry  ]:= blue;

  for i:= 1 to 8 do
  for j:= 1 to 8 do
    hraciPole[ i, j ]:= 0;

  hraciPole[2,1]:=-1;   hraciPole[4,1]:=-1;   hraciPole[6,1]:=-1;   hraciPole[8,1]:=-1;
  hraciPole[1,2]:=-1;   hraciPole[3,2]:=-1;   hraciPole[5,2]:=-1;   hraciPole[7,2]:=-1;
  hraciPole[2,3]:=-1;   hraciPole[4,3]:=-1;   hraciPole[6,3]:=-1;   hraciPole[8,3]:=-1;

  hraciPole[1,6]:=1;    hraciPole[3,6]:=1;    hraciPole[5,6]:=1;    hraciPole[7,6]:=1;
  hraciPole[2,7]:=1;    hraciPole[4,7]:=1;    hraciPole[6,7]:=1;    hraciPole[8,7]:=1;
  hraciPole[1,8]:=1;    hraciPole[3,8]:=1;    hraciPole[5,8]:=1;    hraciPole[7,8]:=1;

  for i:= 1 to 8 do
  for j:= 1 to 8 do
    kreslic.nakresli( i, j, hraciPole[ i, j] );

  reaguj:= FALSE;

  oznacenoX:= 0;    oznacenoY:= 0;

  Form1.Timer1.Enabled:= TRUE;
end;



procedure THra.ovladani( x, y: souradnice );
var
  pTahy: PSeznamTahu;
  pTah: PPrvekSeznamuTahu;
begin
  if reaguj then       // na tahu je clovek
  begin
    if (oznacenoX = 0) and (oznacenoY = 0) then    // jeste neoznacil cim chce tahnout
    begin
      kreslic.oznac( x, y );        // oznacime na co kliknul
      oznacenoX:= x;
      oznacenoY:= y;
    end
    else                           // jiz oznacil cim chce tahnout
    begin
      pTahy:= new( PSeznamTahu, vytvor );
      generator.generuj( naTahu, hraciPole, pTahy^ );      // vygeneruj mozne tahy
      pTah:= pTahy^.najdiTah(oznacenoX, oznacenoY, x, y );   // najdi jestli tam je tah co chtel hrac zahrat
      if (pTah <> NIL) then                // takovy tah existuje
      begin
        Form1.StatusBar1.Panels[0].Text:= '';   // uz mu nerikam ze ma tahnout
        reaguj:= FALSE;                    // hrac uz nemuze ovladat
        tahni( pTah );                           // zahraj ho
        kreslic.odznac( oznacenoX, oznacenoY );  // odznac co bylo oznaceno
        oznacenoX:= 0;
        oznacenoY:= 0;
      end
      else
      begin                                // neexistuje
        kreslic.odznac( oznacenoX, oznacenoY );      // odznac co bylo oznacene
        kreslic.oznac(x, y );                        // oznac novou pozici
        oznacenoX:= x;
        oznacenoY:= y;
      end;
      dispose( pTah, zrus );
      dispose( pTahy, zrus );
    end;
  end;
end;



procedure THra.vykresliVse;
var
  i, j: souradnice;
begin
  for i:= 1 to 8 do
  for j:= 1 to 8 do
    kreslic.nakresli( i, j, hraciPole[ i, j] );
end;



procedure THra.zmenaVDamy;
var
  i: souradnice;
begin
  for i:= 1 to 8 do                     // horni radek
    if ( hraciPole[ i, 1] = 1 ) then    // obsahuje cervenou figuru
      hraciPole[ i, 1]:= 2;             //   -> cervena dama

  for i:= 1 to 8 do                     // dolni radek
    if ( hraciPole[ i, 8] = -1 ) then   // obsahuje modrou figuru
      hraciPole[ i, 8]:= -2;            //   -> modra dama
end;



function THra.konec: boolean;
var
  tahy: PSeznamTahu;
  maFigurky: array[ TypBarvy ] of boolean;
  i, j: souradnice;
begin
  maFigurky[ cerveny ]:= FALSE;
  maFigurky[ modry ]:= FALSE;
  tahy:= new( PSeznamTahu, vytvor );
  generator.generuj( naTahu, hraciPole, tahy^ );
  if tahy^.prazdny then                   // nemuze tahnout
  begin
    for i:= 1 to 8 do                     // ma jeste nejake figurky?
    for j:= 1 to 8 do
    begin
        if (hraciPole[i, j] > 0) then    // cerveny ma figurku
          maFigurky[ cerveny ]:= TRUE;
        if (hraciPole[i, j] < 0) then    // modry ma figurku
          maFigurky[ modry ]:= TRUE;
    end;
    if maFigurky[ naTahu ] then    // ma figury ale nemuze tahnout = REMIS
      Form3.LabelRemiza.Visible:= TRUE
    else                           // nema figurky = prohral
      if (naTahu = cerveny) then   // vyhral modry
        Form3.LabelModry.Visible:= TRUE
      else                         // vyhral cerveny
        Form3.LabelCerveny.Visible:= TRUE;

    Form3.ShowModal;
    konec:= TRUE;
  end
  else                     // muze tahnout = hra pokracuje
    konec:= FALSE;

  dispose( tahy, zrus );
end;



procedure THra.hraj;
var
  pTah: PPrvekSeznamuTahu;
begin
  if konec then         // pokud konec hry pak se k tahu nikdo nedostane
    exit;

  case hraci[ naTahu ] of
    clovek:      // OVLADANI
    begin
      if (naTahu = Cerveny) then
        Form1.StatusBar1.Panels[0].Text:= 'erven jste na tahu'
      else
        Form1.StatusBar1.Panels[0].Text:= 'Modr jste na tahu';
      reaguj:= TRUE;
    end;
    pocitac:     // UMELA INTELIGENCE
    begin
      Form1.StatusBar1.Panels[0].Text:= 'Pota peml...';
      Form1.StatusBar1.Repaint;
      reaguj:= FALSE;
      pTah:= NIL;
      komp.zvolTah( naTahu, hraciPole, pTah );
      tahni( pTah );
      dispose( pTah, zrus );
    end;
  end;
end;



procedure THra.tahni( pTah: PPrvekSeznamuTahu);   // !!! meni obsah PARAMS
var
  sx, sy, cx, cy, bx, by: souradnice;
  kamen: TypKamenu;
begin
  while ( pTah^.vyberBrani( bx, by ) ) do    // vezme figurky co se berou
    hraciPole[ bx, by ]:= 0;

  pTah^.getSouradnice( sx, sy, cx, cy );
  kamen:= hraciPole[ sx, sy ];            // presune kamen jimz se tahne
  hraciPole[ sx, sy ]:= 0;
  hraciPole[ cx, cy ]:= kamen;

  zmenaVDamy;                  // vymeni figurky za damy
  vykresliVse;                 // nakresli provedeni
  if (naTahu = cerveny) then   // nastavi naTahu na druheho
    naTahu:= modry
  else
    naTahu:= cerveny;
  Form1.Timer1.Enabled:= TRUE;   // zapne timer
end;



                  (*****    konec objekt hra   *****)
(******************************************************************************)

end.
