unit UKreslic;

interface

uses UDefinice;

// Kreslic vykresluje hraci plochu na image, ( stav hry a oznaceni pole )

// nakresli - vykresli jedno pole hraci plochy. PARAMS- souradnice, kamen (cerv x modry, dama x norm)
// vymaz - vymaze pole tzn. prekresli ho na prazdne. PARAMS- souradnice
// oznac - kresli obdelnik kolem pole- pro oznaceni pole na ktere se napr kliklo
// odznac - smaze obdelnik kolem pole

type
  TKreslic = object
    public
      procedure nakresli( x, y: integer; co: TypKamenu );
      procedure vymaz( x, y: integer );
      procedure oznac( x, y: souradnice );
      procedure odznac( x, y: souradnice );
  end;
  

var
  kreslic: TKreslic;


implementation

uses Unit1, Graphics, Classes;

(******************************************************************************)
                   (*****   Objekt Kreslic   *****)

const
  myRed = clRed;        // pokud bych chtel barvy trochu (nebo i vice) pozmenit
  myBlue = clBlue;


procedure TKreslic.nakresli( x, y: integer; co: TypKamenu );
begin

  if odd( x + y ) then
  begin
    Form1.image1.canvas.brush.Color := clBlack;
    Form1.image1.canvas.rectangle( ((x-1)*40), ((y-1)*40), x*40 -1, y*40 -1 );
  end
  else
  begin
    Form1.Image1.Canvas.Brush.Color := clWhite;
    Form1.image1.canvas.rectangle( ((x-1)*40), ((y-1)*40), x*40 -1, y*40 -1 );
  end;

  case co of
     1: begin
          Form1.image1.canvas.brush.color := myRed;
          Form1.image1.canvas.ellipse( ((x-1)*40) +5, ((y-1)*40) +5, x*40 -5 -1, y*40 -5 -1);
        end;
    -1: begin
          Form1.image1.canvas.brush.color := myBlue;
          Form1.image1.canvas.ellipse( ((x-1)*40) +5, ((y-1)*40) +5, x*40 -5 -1, y*40  -5 -1);
        end;

     2: begin
          Form1.image1.canvas.brush.color := myRed;
          Form1.image1.canvas.ellipse( ((x-1)*40) + 5, ((y-1)*40) + 5, x*40 - 5 -1, y*40 -5 -1);
          Form1.image1.canvas.brush.color := myBlue;
          Form1.image1.canvas.ellipse( ((x-1)*40) +10, ((y-1)*40) +10, x*40 -10 -1, y*40 -10 -1);
          Form1.image1.canvas.brush.color := myRed;
          Form1.image1.canvas.ellipse( ((x-1)*40) +13, ((y-1)*40) +13, x*40 -13 -1, y*40 -13 -1);
        end;
    -2: begin
          Form1.image1.canvas.brush.color := myBlue;
          Form1.image1.canvas.ellipse( ((x-1)*40)+1 +5, ((y-1)*40)+1 +5, x*40 -5, y*40 -5 );
          Form1.image1.canvas.brush.color := myRed;
          Form1.image1.canvas.ellipse( ((x-1)*40)+1 +10,  ((y-1)*40)+1 +10,  x*40 -10,  y*40 -10 );
          Form1.image1.canvas.brush.color := myBlue;
          Form1.image1.canvas.ellipse( ((x-1)*40)+1 +13,  ((y-1)*40)+1 +13,  x*40 -13,  y*40 -13 );
        end
  end;
end;

procedure TKreslic.vymaz( x, y: integer );
begin
  nakresli( x, y, 0);
end;

procedure TKreslic.oznac( x, y: souradnice );
begin
  form1.image1.canvas.brush.color:= clLime;
  form1.image1.canvas.FrameRect( rect( ((x-1)*40)+1, ((y-1)*40)+1, x*40-2, y*40-2 ) );
  form1.image1.canvas.FrameRect( rect( ((x-1)*40)+2, ((y-1)*40)+2, x*40-3, y*40-3 ) );
  form1.image1.canvas.FrameRect( rect( ((x-1)*40)+3, ((y-1)*40)+3, x*40-4, y*40-4 ) );
end;

procedure TKreslic.odznac( x, y: souradnice );
begin
  if odd(x+y) then
    form1.image1.canvas.brush.color:= clBlack
  else
    form1.image1.canvas.brush.color:= clWhite;
  form1.image1.canvas.FrameRect( rect( ((x-1)*40)+1, ((y-1)*40)+1, x*40-2, y*40-2 ) );
  form1.image1.canvas.FrameRect( rect( ((x-1)*40)+2, ((y-1)*40)+2, x*40-3, y*40-3 ) );
  form1.image1.canvas.FrameRect( rect( ((x-1)*40)+3, ((y-1)*40)+3, x*40-4, y*40-4 ) );
end;


                   (*****   konec Objekt Kreslic   *****)
(******************************************************************************)

end.