unit UPocitac;

interface

uses UDefinice, UGenerator, UDatStr;

// OBJEKT pocitac

// jedna se o realizaci prohledavani do hloubky pomoci minimaxu
// respektive jeho variace nega-maxu
// pouziva alfa-beta prorezavani

// procedura zvolTah vybira nejoptimalnejsi tah, ktery jde hrat z dane pozice
// pouziva na to pomocne funkce ( proceduru )
// procedura provedTah provede na hracim poli dany tah - MENI nejen hraci pole, ale i ten tah
// funkce ohodnotPozici je zminovane prohledavani do hloubky (nega-max s alfa-beta) prorezavanim
// funkce ohodnotHraciPole ohodnoti postaveni za kazdou figuru +1 dama +4 souperovy -1, -4

type
  TPocitac = object
    public
      procedure zvolTah( naTahu: TypBarvy; const hraciPole: THraciPole; var volba: PPrvekSeznamuTahu );
    private
      procedure provedTah( PTah: PPrvekSeznamuTahu; var hraciPole: THraciPole );
      function ohodnotPozici( naTahu: TypBarvy; const hraciPole: THraciPole; uroven, alfa: integer ): integer;
      function ohodnotHraciPole( const hraciPole: THraciPole ): integer;
  end;
  

var
  komp: TPocitac;


implementation


(******************************************************************************)
                  (*****    objekt pocitac   *****)

const
  IQ = 6;
  MAXIMUM = 1000;


procedure TPocitac.zvolTah( naTahu: TypBarvy; const hraciPole: THraciPole; var volba: PPrvekSeznamuTahu );
var
  MozneTahy: PSeznamTahu;
  pomHraciPole: THraciPole;
  max, val: integer;
  pTah, qTah: PPrvekseznamuTahu;
begin
  max:= -MAXIMUM-1;     // inicializace maxima
  MozneTahy:= new( PSeznamTahu, vytvor);
  generator.generuj( naTahu, hraciPole, MozneTahy^ );  // nagenerovani vsech moznych dahu z dane pozice
  while ( not MozneTahy^.prazdny ) do         // dokud jsou nejake neprobadane tahy
  begin
    pomHraciPole:= hraciPole;                    // zkopiruj pozici
    pTah:= MozneTahy^.vyber;
    qTah:= new( PPrvekSeznamuTahu, copy(pTah) );
    provedTah( qTah, pomHraciPole );             // zkus dany tah
    if (naTahu = cerveny) then                                // dle toho kdo je natahu
      val:= - ohodnotPozici( modry, pomHracipole, IQ, -max )     // ohodnot vzniklou situaci
    else
      val:= - ohodnotPozici( cerveny, pomHracipole, IQ, -max );
    // parametr -max znamena ze ze pokud bude ohodnoceni horsi nez max uz nema cenu se s tim zabyvat

    if (val > max) or ( (val = max) and (random > 0.5) ) then           // novy tah je lepsi nez predesly nejlepsi
    begin
      max:= val;
      if volba <> nil then
        dispose( volba, zrus );     // stary nejlepsi se rusi
      volba:= pTah;               // zapamatovani noveho nej tahu
      pTah:= NIL;
    end;
    dispose( pTah, zrus );
    dispose( qTah, zrus );
  end;

  dispose( MozneTahy, zrus );
end;



procedure TPocitac.provedTah( pTah: PPrvekSeznamuTahu; var hraciPole: THraciPole );  // meni PARAMS pTah
var
  bx, by: souradnice;  // pozice kamenu co se vyhazuji
  sx, sy, cx, cy: souradnice;   // start. cil pozice tahu
  i: souradnice;
begin
  while pTah^.vyberBrani( bx, by ) do      // vyhozeni vsech kamenu
    hraciPole[ bx, by ]:= 0;
  pTah^.getSouradnice( sx, sy, cx, cy );
  hracipole[ cx, cy ]:= hraciPole[ sx, sy ];    // presun kamene
  hraciPole[ sx, sy ]:= 0;                      // ---  II  ----
  for i:= 1 to 8 do                       // vymena v damy
  begin
    if (hraciPole[ i, 1 ] = 1) then
      hraciPole[ i, 1 ]:= 2;
    if (hraciPole[ i, 8 ] = -1) then
      hraciPole[ i, 1 ]:= -2;
  end;

end;



function TPocitac.ohodnotPozici( naTahu: TypBarvy; const hraciPole: THraciPole;
                                 uroven, alfa: integer ): integer;
var
  MozneTahy: PSeznamTahu;
  pTah: PPrvekSeznamuTahu;
  pomHraciPole: THraciPole;
  max, val: integer;
begin
  if (uroven = 0) then                   // pokud jsem v pozadovane hloubce
  begin
    if (naTahu = cerveny) then           // pro modre obracene
      ohodnotPozici:= ohodnotHraciPole( hraciPole )
    else
      ohodnotPozici:= - ohodnotHraciPole( hraciPole );
    EXIT;                               // KONEC rekurze
  end;

//  ELSE

  max:= -MAXIMUM;     // inicializace maxima
  MozneTahy:= new( PSeznamTahu, vytvor);
  generator.generuj( naTahu, hraciPole, MozneTahy^ );  // nagenerovani vsech moznych dahu z dane pozice

  if MozneTahy^.prazdny then    // nemuzu tahnout - bud jsem PROHRAL nebo REMIZA
  begin
    dispose( MozneTahy, zrus );
    if ( abs(ohodnotHraciPole( hraciPole )) = MAXIMUM ) then  // nemam figurky PROHRAL jsem
    begin
      ohodnotPozici:= -MAXIMUM;
      exit;
    end
    else   // mam figurky REMIZA
    begin
      ohodnotPozici:= 0;
      exit;
    end;
  end;

  while ( (not MozneTahy^.prazdny) and (max <= alfa) ) do         // dokud jsou nejake neprobadane tahy
  begin                                                          // AND ma smysl tuto vetev dale prozkoumavat
    pomHraciPole:= hraciPole;                    // zkopiruj pozici
    pTah:= MozneTahy^.vyber;
    provedTah( pTah, pomHraciPole );             // zkus dany tah
    dispose( pTah, zrus );
    if (naTahu = cerveny) then                                // dle toho kdo je natahu
      val:= - ohodnotPozici( modry, pomHracipole, uroven-1, -max )     // ohodnot vzniklou situaci
    else
      val:= - ohodnotPozici( cerveny, pomHracipole, uroven-1, -max );
    // parametr -max znamena ze ze pokud bude ohodnoceni horsi nez max uz nema cenu se s tim zabyvat

    if (val > max) then           // novy tah je lepsi nez predesly nejlepsi
      max:= val;
  end;

  dispose( MozneTahy, zrus );
  ohodnotPozici:= max;
end;



function TPocitac.ohodnotHraciPole( const hraciPole: THraciPole ): integer;
var
  sumCerveny, sumModry : integer;
  i,j: souradnice;
begin
    sumCerveny:= 0;
    sumModry:= 0;

    for i:= 1 to 8 do                    // ohodnot vsechny policka
    for j:= 1 to 8 do
    begin
      if (hracipole[i, j] = 1) then      // cena: norm kamen = 1
        sumCerveny:= sumCerveny + 1;
      if (hracipole[i, j] = -1) then
        sumModry:= sumModry - 1;
      if (hracipole[i, j] = 2) then      //       dama = 4
        sumCerveny:= sumCerveny + 4;
      if (hracipole[i, j] = -2) then
        sumModry:= sumModry - 4;
    end;

    if (sumCerveny = 0) then             // cerveny nema figury
    begin
      ohodnothraciPole:= -MAXIMUM;
      exit;
    end;

    if (sumModry = 0) then               // modry nema figury
    begin
      ohodnothraciPole:= MAXIMUM;
      exit;
    end;

    ohodnothraciPole:= (sumCerveny + sumModry) ;

end;

                  (*****    konec objekt pocitac   *****)
(******************************************************************************)

end.